.686
.mmx
.xmm

.RADIX 10
    
.model flat, stdcall
 option casemap :none   ; case sensitive



;**********************************************************************



 ; *** Sort directions ***
 

 increasing_sort_direction                    equ 0
 decreasing_sort_direction                    equ 1



 ; *** datatypes equates ***

 dt_Byte_8                                    equ 0
 dt_Integer_32                                equ 1
 dt_Unsigned_Integer_32                       equ 2
 dt_Single_Precision_Real                     equ 3
 dt_Double_Precision_Real                     equ 4
 dt_Extended_Precision_Real                   equ 5
 dt_Integer_64                                equ 6
 
 dt_Pointer_32                                equ 7
 dt_Null_Terminated_String                    equ 8




;  Search  Functions "not found" constant

 not_found_constant                           equ -1     



; returned status codes, in eax and the Status structure
; status_code field
 
 

 no_error                                     equ  0
 
 null_pointer                                 equ -1
 void_array                                   equ -2
 void_compressed_grade_vector                 equ -3
 void_field                                   equ -4
 
 input_array_alignment_error                  equ -5
 grade_or_output_array_alignment_error        equ -6
 compressed_grade_vector_alignment_error      equ -7
 membership_vector_alignment_error            equ -8
 buffer_alignment_error                       equ -9
 
 input_array_wraparound                       equ -10
 grade_or_output_array_wraparound             equ -11
 buffer_wraparound                            equ -12
 overlapping_input_and_grade_or_output_arrays equ -13
 buffer_and_input_array_overlap               equ -14
 buffer_and_grade_or_output_array_overlap     equ -15
 compressed_grade_vector_wraparound           equ -16
 membership_vector_wraparound                 equ -17
  
 input_array_length_limit_error               equ -18
 grade_vector_length_limit_error              equ -19
 row_length_limit_error                       equ -20
 byte_matrix_row_length_error                 equ -21
 field_length_limit_error                     equ -22
 incompatible_field_lengths                   equ -23
  
 invalid_datatype                             equ -24
 datatype_mismatch                            equ -25 
 first_field_datatype_mismatch                equ datatype_mismatch
 second_field_datatype_mismatch               equ -26
 
 invalid_compression_parameter                equ -27

 invalid_first_compression_parameter          equ  \
 invalid_compression_parameter

 invalid_second_compression_parameter         equ -28

 rank_or_structure_mismatch                   equ -29   

 sort_direction_mismatch                      equ -30
  
 invalid_tuning_parameter                     equ -31

 NaN_or_unsupported_encoding                  equ -64


;*********************************************************************


 Datatype                                   TYPEDEF BYTE
 
 Length_in_Bytes                            TYPEDEF DWORD

 Length_in_Units                            TYPEDEF DWORD

 Index                                      TYPEDEF DWORD

 Count                                      TYPEDEF DWORD

 Div_by_16_Remainder                        TYPEDEF DWORD

 Enabled_if_0                               TYPEDEF DWORD

 Status_Code_errnz                          TYPEDEF SDWORD

 Byte_Status_Code_errnz                     TYPEDEF SBYTE

 Inc_0_Dec_1                                TYPEDEF BYTE

 Indices_Vector                             TYPEDEF PTR Index

 User_Pointer                               TYPEDEF NEAR PTR 

 Void_Pointer                               TYPEDEF NEAR PTR

 Data_Pointer                               TYPEDEF Void_Pointer
 
 Tuning_Parameter                           TYPEDEF PTR REAL8

 Padding_Byte                               TYPEDEF BYTE

 Padding_Dword                              TYPEDEF DWORD

 DBL_QWORD STRUCT
  low_qword                                 QWORD 0
  high_qword                                QWORD 0
 DBL_QWORD ENDS

 Aligned_by_16                              TYPEDEF PTR DBL_QWORD

 _Vector_Dimension STRUCT
  vector_length                             Length_in_Units 0                          
 _Vector_Dimension ENDS 

 Vector_Dimension                           TYPEDEF PTR \
_Vector_Dimension

 _Matrix_Dimensions STRUCT
  first_dimension                           Length_in_Units 0    
  row_length                                Length_in_Units 0                     
 _Matrix_Dimensions ENDS 

 Matrix_Dimensions                          TYPEDEF PTR \
_Matrix_Dimensions

 _Composite_Matrix_Dimensions STRUCT
  first_dimension                           Length_in_Units 0    
  first_field_length                        Length_in_Units 0                     
  second_field_length                       Length_in_Units 0
 _Composite_Matrix_Dimensions ENDS 

 Composite_Matrix_Dimensions                TYPEDEF PTR \
 _Composite_Matrix_Dimensions


 
;********************************************************


 REAL16 STRUCT
  extended_precision_real                   REAL10 0.0
  padding                                   Padding_Byte 6 DUP (0)
 REAL16 ENDS

 LexiFloat STRUCT
  extended_precision_LexiFloat              BYTE 11 DUP(0)
  padding                                   Padding_Byte 0    
 LexiFloat ENDS  


;********************************************************


 Status STRUCT
  allocated_buffer                          Aligned_by_16        0
  real_time_clock_toggle                    Enabled_if_0         0 
  status_code                               Status_Code_errnz    0
  input_array_alignment                     Div_by_16_Remainder  0
  clocks_count_low_dword                    Count                0
  clocks_count_high_dword                   Count                0
  timer_ticks                               Count                0
  padding                                   Padding_Dword 5 DUP (0)
 Status ENDS

 Status_Pointer  TYPEDEF PTR Status
 Status_cast     TEXTEQU <Status PTR> 


;********************************************************


 Utilities_Status STRUCT
  padding_dword_0                           Padding_Dword       0 
  padding_dword_1                           Padding_Dword       0
  status_code                               Status_Code_errnz   0
  NaNs_count                                Count               0
    unsupported_encodings_count               Count               0
  positive_infinities_count                 Count               0
  negative_infinities_count                 Count               0
  denormals_count                           Count               0
  pseudo_denormals_count                    Count               0
  positive_zeroes_count                     Count               0
  negative_zeroes_count                     Count               0
  NaNs_indices_array                        Indices_Vector      0 

 Utilities_Status ENDS

 Utilities_Status_Pointer  TYPEDEF PTR Utilities_Status
 Utilities_Status_cast     TEXTEQU <Utilities_Status PTR> 

 
;********************************************************


 Compression_Record STRUCT
  compression_field_length                  Length_in_Units 0
  grade_vector_first_occurrence_index       Index           0
  input_array_first_occurrence_index        Index           0
  input_array_last_occurrence_index         Index           0
 Compression_Record ENDS


 Compression_Records_Vector TYPEDEF PTR Compression_Record
 compression_record_cast    TEXTEQU <Compression_Record PTR>

 compression_record_length  equ  SIZEOF(Compression_Record)
 

;********************************************************


 Composite_Compression_or_Search_Input STRUCT 
  input_composite_matrix            Data_Pointer               0
  grade_vector                      Indices_Vector             0
  membership_vector                 Indices_Vector             0
  compressed_grade_vector           Compression_Records_Vector 0
  compressed_grade_vector_length    Length_in_Units            0
  first_compression_parameter       Length_in_Units            0
  second_compression_parameter      Length_in_Units            0
  first_dimension                   Length_in_Units            0
  first_field_length                Length_in_Units            0
  second_field_length               Length_in_Units            0
  first_field_datatype              Datatype                   0
  second_field_datatype             Datatype                   0
  sort_direction                    Inc_0_Dec_1                0
  status_code                       Byte_Status_Code_errnz     0
 Composite_Compression_or_Search_Input ENDS


 c_s_i_Pointer TYPEDEF PTR Composite_Compression_or_Search_Input
 c_s_i_cast    TEXTEQU <Composite_Compression_or_Search_Input PTR>


 Composite_Compression_Input           TYPEDEF \
 Composite_Compression_or_Search_Input  

 Composite_Binary_Search_Left_Arg      TYPEDEF \
 Composite_Compression_or_Search_Input

 Composite_Binary_Search_Right_Arg     TYPEDEF \
 Composite_Compression_or_Search_Input

 Composite_Global_Search_Left_Arg      TYPEDEF \
 Composite_Compression_or_Search_Input

 Composite_Global_Search_Right_Arg     TYPEDEF \  
 Composite_Compression_or_Search_Input


;********************************************************


 Matrix_Compression_or_Search_Input STRUCT 
  input_matrix                   Data_Pointer               0
  grade_vector                   Indices_Vector             0
  membership_vector              Indices_Vector             0
  compressed_grade_vector        Compression_Records_Vector 0
  compressed_grade_vector_length Length_in_Units            0
  compression_parameter          Length_in_Units            0
  padding_dword_0                Padding_Dword              0
  first_dimension                Length_in_Units            0
  row_length                     Length_in_Units            0
  padding_dword_1                Padding_Dword              0
  datatype                       Datatype                   0
  padding_byte_0                 Padding_Byte               0
  sort_direction                 Inc_0_Dec_1                0
  status_code                    Byte_Status_Code_errnz     0
 Matrix_Compression_or_Search_Input ENDS

 m_s_i_Pointer TYPEDEF PTR Matrix_Compression_or_Search_input
 m_s_i_cast    TEXTEQU <Matrix_Compression_or_Search_Input PTR>

 Matrix_Compression_Input              TYPEDEF \
 Matrix_Compression_or_Search_Input  

 Matrix_Binary_Search_Left_Arg         TYPEDEF \
 Matrix_Compression_or_Search_Input

 Matrix_Binary_Search_Right_Arg        TYPEDEF \
 Matrix_Compression_or_Search_Input

 Matrix_Global_Search_Left_Arg         TYPEDEF \
 Matrix_Compression_or_Search_Input

 Matrix_Global_Search_Right_Arg        TYPEDEF \
 Matrix_Compression_or_Search_Input



;********************************************************


 Grade_Compression_or_Search_Input STRUCT 
  input_vector                   Data_Pointer               0
  grade_vector                   Indices_Vector             0
  membership_vector              Indices_Vector             0
  compressed_grade_vector        Compression_Records_Vector 0
  compressed_grade_vector_length Length_in_Units            0
  padding_dword_0                Padding_Dword              0
  padding_dword_1                Padding_Dword              0
  input_vector_length            Length_in_Units            0
  padding_dword_2                Padding_Dword              0 
  padding_dword_3                Padding_Dword              0
  datatype                       Datatype                   0
  padding_byte_0                 Padding_Byte               0
  sort_direction                 Inc_0_Dec_1                0
  status_code                    Byte_Status_Code_errnz     0
 Grade_Compression_or_Search_Input ENDS

 v_s_i_Pointer  TYPEDEF PTR Grade_Compression_or_Search_Input
 v_s_i_cast     TEXTEQU <Grade_Compression_or_Search_Input PTR>



 Grade_Compression_Input              TYPEDEF \
 Grade_Compression_or_Search_Input  

 Grade_Binary_Search_Left_Arg         TYPEDEF \
 Grade_Compression_or_Search_Input

 Grade_Binary_Search_Right_Arg        TYPEDEF \
 Grade_Compression_or_Search_Input

 Grade_Global_Search_Left_Arg         TYPEDEF  \
 Grade_Compression_or_Search_Input

 Grade_Global_Search_Right_Arg        TYPEDEF \
 Grade_Compression_or_Search_Input

 
;********************************************************


Comparison_Function TYPEDEF PROTO STDCALL\
left_argument:User_Pointer,right_argument:User_Pointer


; InPlace_Call_Inc PROTO STDCALL\ 
; :Tuning_Parameter,\
; :PTR Comparison_Function,\
; :Status_Pointer,\
; :Vector_Dimension,\
; input_output_array:PTR User_Pointer

; InPlace_Call_Dec PROTO STDCALL\
; :Tuning_Parameter,\
; :PTR Comparison_Function,\
; :Status_Pointer,\
; :Vector_Dimension,\
; input_output_array:PTR User_Pointer

InPlace_Call_fn TYPEDEF PROTO STDCALL\
:Tuning_Parameter,\
:PTR Comparison_Function,\
:Status_Pointer,:Vector_Dimension,\
input_output_array: PTR User_Pointer

InPlace_Call_Inc_ptr TYPEDEF PTR InPlace_Call_fn
InPlace_Call_Dec_ptr TYPEDEF PTR InPlace_Call_fn



; Grade_Call_Inc PROTO STDCALL\
; :Tuning_Parameter,\
; :PTR Comparison_Function,\
; :Status_Pointer,\
; :Vector_Dimension,\
; input_array:PTR User_Pointer,\
; grade_vector:Indices_Vector

; Grade_Call_Dec PROTO STDCALL\
; :Tuning_Parameter,\
; :PTR Comparison_Function,\
; :Status_Pointer,\
; :Vector_Dimension,\
; input_array:PTR User_Pointer,\
; grade_vector:Indices_Vector

Grade_Call_fn TYPEDEF PROTO STDCALL\
:Tuning_Parameter,\
:PTR Comparison_Function,\
:Status_Pointer,\
:Vector_Dimension,\
input_array: PTR User_Pointer,\
grade_vector:Indices_Vector

Grade_Call_Inc_ptr TYPEDEF PTR Grade_Call_fn
Grade_Call_Dec_ptr TYPEDEF PTR Grade_Call_fn



; C_Grade_Call_Inc PROTO STDCALL\
; :PTR Comparison_Function,\
; :PTR Grade_Compression_Input

; C_Grade_Call_Dec PROTO STDCALL\
; :PTR Comparison_Function,\
; :PTR Grade_Compression_Input

C_Grade_Call_fn TYPEDEF PROTO STDCALL\
:PTR Comparison_Function,\
:PTR Grade_Compression_Input

C_Grade_Call_Inc_ptr TYPEDEF PTR C_Grade_Call_fn
C_Grade_Call_Dec_ptr TYPEDEF PTR C_Grade_Call_fn 



; B_Grade_Call_Inc PROTO STDCALL\
; :PTR Comparison_Function,\
; :PTR Grade_Binary_Search_Left_Arg,\
; :PTR Grade_Binary_Search_Right_Arg

; B_Grade_Call_Dec PROTO STDCALL\
; :PTR Comparison_Function,\
; :PTR Grade_Binary_Search_Left_Arg,\
; :PTR Grade_Binary_Search_Right_Arg

B_Grade_Call_fn TYPEDEF PROTO STDCALL\
:PTR Comparison_Function,\
:PTR Grade_Binary_Search_Left_Arg,\
:PTR Grade_Binary_Search_Right_Arg

B_Grade_Call_Inc_ptr TYPEDEF PTR B_Grade_Call_fn
B_Grade_Call_Dec_ptr TYPEDEF PTR B_Grade_Call_fn



; S_Grade_Call_Inc PROTO STDCALL\
; :PTR Comparison_Function,\
; :PTR Grade_Global_Search_Left_Arg,\
; :PTR Grade_Global_Search_Right_Arg

; S_Grade_Call_Dec PROTO STDCALL\
; :PTR Comparison_Function,\
; :PTR Grade_Global_Search_Left_Arg,\
; :PTR Grade_Global_Search_Right_Arg

S_Grade_Call_fn TYPEDEF PROTO STDCALL\
:PTR Comparison_Function,\
:PTR Grade_Global_Search_Left_Arg,\
:PTR Grade_Global_Search_Right_Arg

S_Grade_Call_Inc_ptr TYPEDEF PTR S_Grade_Call_fn
S_Grade_Call_Dec_ptr TYPEDEF PTR S_Grade_Call_fn





InPlace_decl MACRO fname:REQ, datatype:=<Void_Pointer>

 fname PROTO STDCALL\
 :Tuning_Parameter,\
 :Status_Pointer,\
 :Vector_Dimension,\
 input_output:PTR datatype
  
ENDM
 

InPlace_ptr MACRO fname:REQ, datatype:=<Void_Pointer>

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :Tuning_Parameter,\
 :Status_Pointer,\
 :Vector_Dimension,\
 input_output:PTR datatype

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Direct_decl MACRO fname:REQ, datatype:=<Void_Pointer>

 fname PROTO STDCALL\
 :Status_Pointer,\
 :Vector_Dimension,\
 input_array:PTR datatype,\
 output_array:PTR datatype
  
ENDM
 

Direct_ptr MACRO fname:REQ, datatype:=<Void_Pointer>

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :Status_Pointer,\
 :Vector_Dimension,\
 input_array:PTR datatype,\
 output_array:PTR datatype

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM



Grade_decl MACRO fname:REQ, datatype:=<Void_Pointer>

  fname PROTO STDCALL\
  :Status_Pointer,\
  :Vector_Dimension,\
  input_array:PTR datatype,\
  grade_vector:Indices_Vector
  
ENDM
 

Grade_ptr MACRO fname:REQ, datatype:=<Void_Pointer>

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :Status_Pointer,\
 :Vector_Dimension,\
 input_array:PTR datatype,\
 grade_vector:Indices_Vector

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Grade_Compression_decl MACRO fname

 fname PROTO STDCALL :PTR Grade_Compression_Input
  
ENDM
 

Grade_Compression_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>
 fname_fn   TYPEDEF PROTO STDCALL :PTR Grade_Compression_Input
 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Grade_Binary_Search_decl MACRO fname

 fname PROTO STDCALL\
 :PTR Grade_Binary_Search_Left_Arg,\
 :PTR Grade_Binary_Search_Right_Arg
  
ENDM


Grade_Binary_Search_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :PTR Grade_Binary_Search_Left_Arg,\
 :PTR Grade_Binary_Search_Right_Arg

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Grade_Global_Search_decl MACRO fname

 fname PROTO STDCALL\
 :PTR Grade_Global_Search_Left_Arg,\
 :PTR Grade_Global_Search_Right_Arg
  
ENDM


Grade_Global_Search_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :PTR Grade_Global_Search_Left_Arg,\
 :PTR Grade_Global_Search_Right_Arg

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM




Matrix_decl MACRO fname:REQ, datatype:=<Void_Pointer>

  fname PROTO STDCALL\
  :Status_Pointer,\
  :Matrix_Dimensions,\
  input_array:PTR datatype,\
  grade_vector:Indices_Vector
  
ENDM
 

Matrix_ptr MACRO fname:REQ, datatype:=<Void_Pointer>

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :Status_Pointer,\
 :Matrix_Dimensions,\
 input_array:PTR datatype,\
 grade_vector:Indices_Vector

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Matrix_Compression_decl MACRO fname

 fname PROTO STDCALL :PTR Matrix_Compression_Input
  
ENDM
 

Matrix_Compression_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>
 fname_fn   TYPEDEF PROTO STDCALL :PTR Matrix_Compression_Input
 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Matrix_Binary_Search_decl MACRO fname

 fname PROTO STDCALL\
 :PTR Matrix_Binary_Search_Left_Arg,\
 :PTR Matrix_Binary_Search_Right_Arg
  
ENDM
 

Matrix_Binary_Search_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :PTR Matrix_Binary_Search_Left_Arg,\
 :PTR Matrix_Binary_Search_Right_Arg

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM

Matrix_Global_Search_decl MACRO fname

 fname PROTO STDCALL\
 :PTR Matrix_Global_Search_Left_Arg,\
 :PTR Matrix_Global_Search_Right_Arg
  
ENDM
 

Matrix_Global_Search_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :PTR Matrix_Global_Search_Left_Arg,\
 :PTR Matrix_Global_Search_Right_Arg

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM



Composite_decl MACRO fname:REQ, datatype:=<Void_Pointer>

  fname PROTO STDCALL\ 
  :Status_Pointer,\
  :Composite_Matrix_Dimensions,\
  input_array:PTR datatype,\
  grade_vector:Indices_Vector
  
ENDM
 

Composite_ptr MACRO fname:REQ, datatype:=<Void_Pointer>

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :Status_Pointer,\
 :Composite_Matrix_Dimensions,\
 input_array:PTR datatype,\
 grade_vector:Indices_Vector

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Composite_Compression_decl MACRO fname

 fname PROTO STDCALL :PTR Composite_Compression_Input
  
ENDM
 

Composite_Compression_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>
 fname_fn   TYPEDEF PROTO STDCALL :PTR Composite_Compression_Input
 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Composite_Binary_Search_decl MACRO fname

 fname PROTO STDCALL\
:PTR Composite_Binary_Search_Left_Arg,\
:PTR Composite_Binary_Search_Right_Arg
  
ENDM
 

Composite_Binary_Search_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :PTR Composite_Binary_Search_Left_Arg,\
 :PTR Composite_Binary_Search_Right_Arg

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


Composite_Global_Search_decl MACRO fname

 fname PROTO STDCALL\
 :PTR Composite_Global_Search_Left_Arg,\
 :PTR Composite_Global_Search_Right_Arg
  
ENDM
 

Composite_Global_Search_ptr MACRO fname

 LOCAL fname_fn,fname_ptr
 
 fname_fn   TEXTEQU <&fname&_fn>
 fname_ptr  TEXTEQU <&fname&_ptr>

 fname_fn   TYPEDEF PROTO STDCALL\
 :PTR Composite_Global_Search_Left_Arg,\
 :PTR Composite_Global_Search_Right_Arg

 fname_ptr  TYPEDEF PTR fname_fn
  
ENDM


;********************************************************************
 

; Reorder_Array PROTO STDCALL\
; :Utilities_Status_Pointer,\
; source_array:Void_Pointer,\
; destination_array:Void_Pointer,\
; indices_array:Indices_Vector,\
; indices_array_length:Length_in_Units,\
; unit_length:Length_in_Bytes

  Reorder_Array_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  source_array:Void_Pointer,\
  destination_array:Void_Pointer,\
  indices_array:Indices_Vector,\
  indices_array_length:Length_in_Units,\
  unit_length:Length_in_Bytes                       

  Reorder_Array_ptr TYPEDEF PTR Reorder_Array_fn



; Link_Array PROTO STDCALL:Utilities_Status_Pointer,\
; array_first_dimension:Length_in_Units,\
; compressed_grade_vector_length:Length_in_Units,\
; grade_vector:Indices_Vector,\
; compressed_grade_vector:Compression_Records_Vector,\
; link_array:Indices_Vector

  Link_Array_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  array_first_dimension:Length_in_Units,\
  compressed_grade_vector_length:Length_in_Units,\
  grade_vector:Indices_Vector,\
  compressed_grade_vector:Compression_Records_Vector,\
  link_array:Indices_Vector

  Link_Array_ptr TYPEDEF PTR Link_Array_fn



; DQword_Transpose PROTO STDCALL\
; :Utilities_Status_Pointer,\
; source_array:PTR DBL_QWORD,\
; destination_array:PTR DBL_QWORD,\
; first_dimension:Length_in_Units,\
; row_length:Length_in_Units

  DQword_Transpose_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  source_array:PTR DBL_QWORD,\
  destination_array:PTR DBL_QWORD,\
  first_dimension:Length_in_Units,\
  row_length:Length_in_Units

  DQword_Transpose_ptr TYPEDEF PTR DQword_Transpose_fn

 
; Qword_Transpose PROTO STDCALL\
; :Utilities_Status_Pointer,\
; source_array:PTR QWORD,\
; destination_array:PTR QWORD,\
; first_dimension:Length_in_Units,\
; row_length:Length_in_Units

  Qword_Transpose_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  source_array:PTR QWORD,\
  destination_array:PTR QWORD,\
  first_dimension:Length_in_Units,\
  row_length:Length_in_Units

  Qword_Transpose_ptr TYPEDEF PTR Qword_Transpose_fn

 
; Dword_Transpose PROTO STDCALL\
; :Utilities_Status_Pointer,\
; source_array:PTR DWORD,\
; destination_array:PTR DWORD,\
; first_dimension:Length_in_Units,\
; row_length:Length_in_Units

  Dword_Transpose_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  source_array:PTR DWORD,\
  destination_array:PTR DWORD,\
  first_dimension:Length_in_Units,\
  row_length:Length_in_Units

  Dword_Transpose_ptr TYPEDEF PTR Dword_Transpose_fn


; Byte_Transpose PROTO STDCALL\
; :Utilities_Status_Pointer,\
; source_array:PTR BYTE,\
; destination_array:PTR BYTE,\
; first_dimension:Length_in_Units,\
; row_length:Length_in_Units

  Byte_Transpose_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  source_array:PTR BYTE,\
  destination_array:PTR BYTE,\
  first_dimension:Length_in_Units,\
  row_length:Length_in_Units

  Byte_Transpose_ptr TYPEDEF PTR Byte_Transpose_fn




; ScanFloat_Composite_Real10 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; input_array:Void_Pointer,\
; input_array_first_dimension:Length_in_Units,\
; row_length:Length_in_Bytes,\
; pos_or_neg_field_length_in_units:SDWORD

  ScanFloat_Composite_Real10_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  input_array:Void_Pointer,\
  input_array_first_dimension:Length_in_Units,\
  row_length:Length_in_Bytes,\
  pos_or_neg_field_length_in_units:SDWORD

  ScanFloat_Composite_Real10_ptr TYPEDEF\
  PTR ScanFloat_Composite_Real10_fn


; ScanFloat_Composite_Real8 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; input_array:Void_Pointer,\
; input_array_first_dimension:Length_in_Units,\
; row_length:Length_in_Bytes,\
; pos_or_neg_field_length_in_units:SDWORD

  ScanFloat_Composite_Real8_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  input_array:Void_Pointer,\
  input_array_first_dimension:Length_in_Units,\
  row_length:Length_in_Bytes,\
  pos_or_neg_field_length_in_units:SDWORD

  ScanFloat_Composite_Real8_ptr TYPEDEF\
  PTR ScanFloat_Composite_Real8_fn


; ScanFloat_Composite_Real4 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; input_array:Void_Pointer,\
; input_array_first_dimension:Length_in_Units,\
; row_length:Length_in_Bytes,\
; pos_or_neg_field_length_in_units:SDWORD

  ScanFloat_Composite_Real4_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  input_array:Void_Pointer,\
  input_array_first_dimension:Length_in_Units,\
  row_length:Length_in_Bytes,\
  pos_or_neg_field_length_in_units:SDWORD

  ScanFloat_Composite_Real4_ptr TYPEDEF\
  PTR ScanFloat_Composite_Real4_fn


; ScanFloat_Vector_Real10 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; input_vector:PTR REAL16,\
; vector_length:Length_in_Units

  ScanFloat_Vector_Real10_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  input_vector:PTR REAL16,\
  vector_length:Length_in_Units

  ScanFloat_Vector_Real10_ptr TYPEDEF\
  PTR ScanFloat_Vector_Real10_fn



; ScanFloat_Vector_Real8 PROTO STDCALL\ 
; :Utilities_Status_Pointer,\
; input_vector:PTR REAL8,\
; vector_length:Length_in_Units

  ScanFloat_Vector_Real8_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  input_vector:PTR REAL8,\
  vector_length:Length_in_Units

  ScanFloat_Vector_Real8_ptr TYPEDEF PTR ScanFloat_Vector_Real8_fn


; ScanFloat_Vector_Real4 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; input_vector:PTR REAL4,\
; vector_length:Length_in_Units

  ScanFloat_Vector_Real4_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  input_vector:PTR REAL4,\
  vector_length:Length_in_Units

  ScanFloat_Vector_Real4_ptr TYPEDEF PTR ScanFloat_Vector_Real4_fn



; CleanFloat_Real10 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; Real10_Vector:PTR REAL16,\
; Real10_Vector_Length:Length_in_Units

  CleanFloat_Real10_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  Real10_Vector:PTR REAL16,\
  Real10_Vector_Length:Length_in_Units

  CleanFloat_Real10_ptr TYPEDEF PTR CleanFloat_Real10_fn


; CleanFloat_Real8 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; Real8_Vector:PTR REAL8,\
; Real8_Vector_Length:Length_in_Units

  CleanFloat_Real8_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  Real8_Vector:PTR REAL8,\
  Real8_Vector_Length:Length_in_Units

  CleanFloat_Real8_ptr TYPEDEF PTR CleanFloat_Real8_fn


; CleanFloat_Real4 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; Real4_Vector:PTR REAL4,\
; Real4_Vector_Length:Length_in_Units

  CleanFloat_Real4_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  Real4_Vector:PTR REAL4,\
  Real4_Vector_Length:Length_in_Units

  CleanFloat_Real4_ptr TYPEDEF PTR CleanFloat_Real4_fn




; Real10_to_LexiFloat PROTO STDCALL\
; :Utilities_Status_Pointer,\
; : Real10_Vector:PTR REAL16,\
; LexiFloat_Matrix:PTR LexiFloat,\
; Real10_Vector_Length:Length_in_Units

  Real10_to_LexiFloat_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  Real10_Vector:PTR REAL16,\
  LexiFloat_Matrix:PTR LexiFloat,\
  Real10_Vector_Length:Length_in_Units 

  Real10_to_LexiFloat_ptr TYPEDEF PTR Real10_to_LexiFloat_fn


; LexiFloat_to_Real10 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; LexiFloat_Matrix:PTR LexiFloat,\
; Real10_Vector:PTR REAL16,\
; LexiFloat_Matrix_first_dimension:Length_in_Units

  LexiFloat_to_Real10_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  LexiFloat_Matrix:PTR LexiFloat,\
  Real10_Vector:PTR REAL16,\
  LexiFloat_Matrix_first_dimension:Length_in_Units

  LexiFloat_to_Real10_ptr TYPEDEF PTR LexiFloat_to_Real10_fn

 

; Real8_to_LexiFloat PROTO STDCALL\
; :Utilities_Status_Pointer,\
; Real8_Vector:PTR REAL8,\
; LexiFloat_Matrix:PTR LexiFloat,\
; Real8_Vector_Length:Length_in_Units

  Real8_to_LexiFloat_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  Real8_Vector:PTR REAL8,\
  LexiFloat_Matrix:PTR LexiFloat,\
  Real8_Vector_Length:Length_in_Units 

  Real8_to_LexiFloat_ptr TYPEDEF PTR Real8_to_LexiFloat_fn


; LexiFloat_to_Real8 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; LexiFloat_Matrix:PTR LexiFloat,\
; Real8_Vector:PTR REAL8,\
; LexiFloat_Matrix_first_dimension:Length_in_Units

  LexiFloat_to_Real8_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  LexiFloat_Matrix:PTR LexiFloat,\
  Real8_Vector:PTR REAL8,\
  LexiFloat_Matrix_first_dimension:Length_in_Units

  LexiFloat_to_Real8_ptr TYPEDEF PTR LexiFloat_to_Real8_fn



; Real4_to_LexiFloat PROTO STDCALL\
; :Utilities_Status_Pointer,\
; Real4_Vector:PTR REAL4,\
; LexiFloat_Matrix:PTR LexiFloat,\
; Real4_Vector_Length:Length_in_Units

  Real4_to_LexiFloat_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  Real4_Vector:PTR REAL4,\
  LexiFloat_Matrix:PTR LexiFloat,\
  Real4_Vector_Length:Length_in_Units 

  Real4_to_LexiFloat_ptr TYPEDEF PTR Real4_to_LexiFloat_fn


; LexiFloat_to_Real4 PROTO STDCALL\
; :Utilities_Status_Pointer,\
; LexiFloat_Matrix:PTR LexiFloat,\
; Real4_Vector:PTR REAL4,\
; LexiFloat_Matrix_first_dimension:Length_in_Units

  LexiFloat_to_Real4_fn TYPEDEF PROTO STDCALL\
  :Utilities_Status_Pointer,\
  LexiFloat_Matrix:PTR LexiFloat,\
  Real4_Vector:PTR REAL4,\
  LexiFloat_Matrix_first_dimension:Length_in_Units

  LexiFloat_to_Real4_ptr TYPEDEF PTR LexiFloat_to_Real4_fn
